package hage;

import kha.Image;

/**
 * ...
 * @author JanGamesCo
 */
class HGE
{
	/***Public vars***/
	//Game reference
	public static var game:HGEGame;
	public static var backbuffer:Image;

	//Engine parameters
	public static var width:Int = 0;
	public static var height:Int = 0;
	public static var gameScale:HGEVector2 = new HGEVector2(1, 1);
	public static var pause:Bool = false;

	//Engine components
	public static var input:HGEInput;

	//Global variables
	public static var lastTime:Float = 0;
	public static var delta:Float = 0;

	//Private HGE varibales
	public static var lastID:Int = 0;
	
	//Debug flag
	#if debug
	public static var debug:Bool = false;
	#end

	/***Public functions***/	
	/*Return a new id and increment lastID*/
	public static function getID():Int
	{
		return lastID++;
	}

	/*Check if points overlaps sprite*/
	public static function overlapPoint(X:Float, Y:Float, Data:HGESprite):Bool
	{
		if( X > Data.x && X < Data.x + Data.width && 
			Y > Data.y && Y < Data.y + Data.height) {
			return true;
		}
		return false;
	}

	/*Check if sprites overlap each other*/
	public static function overlap(Sprite1:HGESprite, Sprite2:HGESprite):Bool
	{
		if( Sprite1.x < Sprite2.x + Sprite2.width &&
			Sprite1.x + Sprite1.width > Sprite2.x &&
			Sprite1.y < Sprite2.y + Sprite2.height &&
			Sprite1.y + Sprite1.height > Sprite2.y) {
			return true;
		}
		return false;
	}

}