package hage;

import hage.HGEData.TextAlign;
import haxe.xml.Fast;
import kha.math.FastMatrix3;
import kha.Scaler;

import kha.Color;
import kha.Font;

/**
 * ...
 * @author JanGamesCo
 */
class HGEText extends HGESprite
{	
	/** Text font */
	public var font:Font;
	/** Set and get text */
	public var text(default, set):String;
	/** Text align */
	public var horizontalAlign:TextAlign;
	public var verticalAlign:TextAlign;

	/** Create text */
	public function new(X:Float, Y:Float, Size:Float, FontVal:Font, ColorV:UInt = 0xFFFFFFFF, Alpha:Float = 1) 
	{		
		super(X, Y, 1, 1, ColorV, Alpha);
		
		//Default text align
		horizontalAlign = TextAlign.LEFT;
		verticalAlign = TextAlign.TOP;
		
		//Setup font
		font = FontVal;
		
		width = HGE.width;
		height = HGE.height;
		
		//Default text
		text = "";
	}
	
	/** Center text */
	public function setAlign(HorizontalAlign:TextAlign = null, Width:Float = 0, VerticalAlign:TextAlign = null, Height:Float = 0):Void
	{
		if(HorizontalAlign != null) { horizontalAlign = HorizontalAlign; }
		if(VerticalAlign != null) { verticalAlign = VerticalAlign; }
		width = Width;
		height = Height;
	}
	
	/** Draw x position */
	/** Draw function */
	override public function draw():Void
	{
		HGE.backbuffer.g2.set_color(color);
		
		HGE.backbuffer.g2.font = font;
		
		HGE.backbuffer.g2.pushTransformation(matrix);
		var split:Array<String> = text.split("\n");
		var drawx:Float = x;
		var drawy:Float = y;
		var ydelta:Float = font.getHeight();
		switch (verticalAlign)
		{
			case TextAlign.BOTTOM:
				ydelta = -font.getHeight();
				drawy = y + ydelta;
			case TextAlign.CENTER:
				drawy = y + height / 2 - font.getHeight() / 2;
			case TextAlign.TOP:
				drawy = y;
				ydelta = font.getHeight();
			default:
				ydelta = font.getHeight();
		}
		HGE.backbuffer.g2.popTransformation();
		
		var i:Int = 0;
		for (t in split) {
			switch (horizontalAlign)
			{
				case TextAlign.LEFT:
					drawx = x;
				case TextAlign.CENTER:
					drawx = x + Math.floor((width - font.stringWidth(t) * scaleX) / 2);
				case TextAlign.RIGHT:
					drawx = x + width - font.stringWidth(t);
				default:
					drawx = x;
			}
			matrix._20 = drawx;
			matrix._21 = drawy + i * ydelta;
			HGE.backbuffer.g2.drawString(t, matrix._20, matrix._21);
			i++;
		}
		
		return;
	}
	
	/** Text setter */
	private function set_text(Value:String):String {
		text = Value;
		
		return text;
	}
	
}