package hage;

/**
 * ...
 * @author JanGames
 */
class HGEVector2
{
	/***Public vars***/
	public var x:Float;
	public var y:Float;	
	
	/***Public functions***/
	public function new(X:Float = 0, Y:Float = 0) 
	{
		x = X;
		y = Y;
	}
	
	//Vector copy
	public inline function copy():HGEVector2
	{
		return new HGEVector2(x, y);
	}
	
	//Vector set
	public inline function set(X:Float, Y:Float):HGEVector2
	{
		x = X;
		y = Y;
		return this;
	}
	
	//Simple vector addition
	public function add(Other:HGEVector2):HGEVector2
	{
		return set(x + Other.x, y + Other.y);
	}
	
	//Simple vector subtraction
	public function sub(Other:HGEVector2):HGEVector2
	{
		return set(x - Other.x, y - Other.y);
	}
	
	//Vector multiplication by scalar
	public function mul(Value:Float):HGEVector2
	{
		return set(x * Value, y * Value);
	}
	
	//Dot product
	public function dot(Other:HGEVector2):Float
	{
		return x * Other.x + y * Other.y;
	}
	
	//Vector distance
	public function distance(Other:HGEVector2):Float
	{
		return copy().sub(Other).magnitude();
	}
	
	//Rotate vector by an angle in radians
	public function rotate(Value:Float):HGEVector2
	{
		return set(x * Math.cos(Value) - y * Math.sin(Value), x * Math.sin(Value) + y * Math.cos(Value));
	}
	
	//Vector magnitude
	public function magnitude():Float
	{
		return Math.sqrt(x * x + y * y);
	}
	
	//Vector angle
	public function angle():Float
	{
		return Math.atan2(-y, x);
	}
	
	//Vector angle
	public function angleTo(Other:HGEVector2):Float
	{
		return Math.atan2(-(y - Other.y), -(x - Other.x));
	}
}