package;

import hage.HGE;
import hage.HGEGroup;
import hage.HGEObject;
import hage.HGEPool;
import kha.Font;
import kha.Loader;
import kha.Sound;
import levels.LevelBase;
import ships.Boss01;
import ships.Boss01Pool;
import ships.Boss02Pool;
import ships.Boss03Pool;
import ships.Enemy01;
import ships.Enemy01Pool;
import ships.JointPool;
import ships.Player;
import ships.PlayerBulletsPool;
import ships.PlayerPool;

import ships.EnemyBulletsPool;

/**
 * ...
 * @author JanGames
 */
class Data
{
	/**Singleton reference*/
	public static var the:Data;
	
	public var nokiaFont:Font;
	public var arialFont:Font;
	
	/** Enemy pools */
	public var enemy01Pool:Enemy01Pool;
	public var jointPool:JointPool;
	
	/** Boss references */
	public var boss01Pool:Boss01Pool;
	public var boss02Pool:Boss02Pool;
	public var boss03Pool:Boss03Pool;
	//public var boss03
	//public var boss04
	//public var boss05
	
	/** */
	public var playerShipPool:PlayerPool;
	
	/** */
	public var levels:HGEGroup<LevelBase>;
	
	/** Enemy bullet pool */
	public var enemyPool:EnemyBulletsPool;
	public var player:Player;
	public var playerPool:PlayerBulletsPool;
	
	/** */
	public var backGroup:HGEGroup<HGEObject>;
	
	public var shoot1:Sound;
	public var shoot2:Sound;
	public var powerup1:Sound;
	public var explosion1:Sound;
	public var explosion2:Sound;
	
	/** */
	public var virtualYPos:Float;
	public var playerSpeed:Float;
	
	public var level:Int;
	
	public var gameover:Bool;
	public var gamewon:Bool;
	
	/**Breakout game reference*/
	public var game:LDGame;
	
	public function new()
	{
		reset();
		
		//Init vals
		virtualYPos = 0;
		playerSpeed = 10;
		level = -1;
		gameover = false;
		gamewon = false;
		
		//Load sound
		shoot1 = Loader.the.getSound("Shoot1");
		shoot2 = Loader.the.getSound("Shoot2");
		powerup1 = Loader.the.getSound("Powerup1");
		explosion1 = Loader.the.getSound("Explosion1");
		explosion2 = Loader.the.getSound("Explosion2");
		
		//Init
		levels = new HGEGroup();
		HGE.game.add(levels);
		
		backGroup = new HGEGroup();
		HGE.game.add(backGroup);
		
		playerShipPool = new PlayerPool();
		HGE.game.add(playerShipPool);
		
		enemy01Pool = new Enemy01Pool();
		HGE.game.add(enemy01Pool);
		jointPool = new JointPool();
		HGE.game.add(jointPool);
		boss01Pool = new Boss01Pool();
		HGE.game.add(boss01Pool);
		boss02Pool = new Boss02Pool();
		HGE.game.add(boss02Pool);
		boss03Pool = new Boss03Pool();
		HGE.game.add(boss03Pool);
		
		enemyPool = new EnemyBulletsPool();
		HGE.game.add(enemyPool);
		playerPool = new PlayerBulletsPool();
		HGE.game.add(playerPool);
		
		//Set reference
		the = this;
	}
	
	//Reset data
	public function reset()
	{
		
	}
	
}