package ships;

import hage.HGE;
import hage.HGEObject;
import hage.HGEGroup;
import kha.Color;
import ships.Enemy01.Enemy01Type;

/**
 * ...
 * @author JanGamesCo
 */
class Boss01 extends EnemyBase
{
	public var isBoss:Bool;
	
	public var parts:HGEGroup<HGEObject>;
	
	public function new(X:Float=0, Y:Float=0) 
	{
		parts = new HGEGroup();
		
		super(X, Y, 32, 32);
		
		//Border
		borderColor = Color.fromValue(0xFFFF3030);
		borderStrength = 2;	
		
		growth = 6;		
		
		reset();
	}
	
	override public function update():Void 
	{
		super.update();
		
		if (isBoss && Data.the.level != -1) {
			x = Math.sin(HGE.lastTime * 0.25) * (HGE.width - 80) / 2 + HGE.width / 2 - width / 2;
			if(y > 100) { velocity.set(0, 0); }
		}
	}
	
	override public function kill():Void 
	{
		super.kill();
		
		if (isBoss) {
			Data.the.game.nextLevel();
		}
	}
	
	override public function reset():Void 
	{
		super.reset();
		
		for (part in parts.members) {
			part.detach();
			part.kill();
		}
		parts = new HGEGroup();
		
		isBoss = false;
		
		health = 5;
		
		var joint:Joint = Data.the.jointPool.create(x + 32, y + 12, 24, 8, health / 2);
		joint.attach(this, 32, 12);
		parts.push(joint);
		
		var enemy:Enemy01 = Data.the.enemy01Pool.create(joint.x + 25, joint.y - 4, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, 25, -4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x - 24, y + 12, 24, 8, health / 2);
		joint.attach(this, -24, 12);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x - 17, joint.y - 4, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, -17, -4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x + 12, y + 32, 8, 24, health / 2);
		joint.attach(this, 12, 32);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 4, joint.y + 24, Enemy01Type.Triangle);
		enemy.health = health;
		enemy.attach(joint, 4, 24);
		parts.push(enemy);
	}
	
}