package ships;

import hage.HGE;
import hage.HGEObject;
import hage.HGEGroup;
import kha.Color;
import ships.Enemy01.Enemy01Type;

/**
 * ...
 * @author JanGamesCo
 */
class Boss02 extends EnemyBase
{
	public var isBoss:Bool;
	
	public var parts:HGEGroup<HGEObject>;
	
	public function new(X:Float=0, Y:Float=0) 
	{
		parts = new HGEGroup();
		
		super(X, Y, 48, 48);
		
		//Border
		borderColor = Color.fromValue(0xFFFF3030);
		borderStrength = 2;	
		
		growth = 9;
		
		reset();
	}
	
	override public function update():Void 
	{
		super.update();
		
		if (isBoss && Data.the.level != -1) {
			x = Math.sin(HGE.lastTime * 0.25) * (HGE.width - 120) / 2 + HGE.width / 2 - width / 2;
			if(y > 100) { velocity.set(0, 0); }
		}
	}
	
	override public function kill():Void 
	{
		super.kill();
		
		if (isBoss) {
			Data.the.game.nextLevel();
		}
	}
	
	override public function reset():Void 
	{
		super.reset();
		
		for (part in parts.members) {
			part.detach();
			part.kill();
		}
		parts = new HGEGroup();
		
		isBoss = false;
		
		health = 8;
		
		var joint:Joint = Data.the.jointPool.create(x + 48, y + 12, 36, 8, health / 2);
		joint.attach(this, 48, 12);
		parts.push(joint);
		
		var enemy:Enemy01 = Data.the.enemy01Pool.create(joint.x + 25, joint.y - 4, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, 33, -4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x + 48, y + 36, 24, 8, health / 2);
		joint.attach(this, 48, 36);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 25, joint.y - 4, Enemy01Type.Triangle);
		enemy.health = health;
		enemy.attach(joint, 24, 4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x - 36, y + 12, 36, 8, health / 2);
		joint.attach(this, -36, 12);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x - 16, joint.y - 4, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, -16, -4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x - 24, y + 36, 24, 8, health / 2);
		joint.attach(this, -24, 36);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x - 16, joint.y - 4, Enemy01Type.Triangle);
		enemy.health = health;
		enemy.attach(joint, 0, 4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x + 4, y + 48, 8, 12, health / 2);
		joint.attach(this, 4, 48);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 4, joint.y + 24, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, -4, 12);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x + 36, y + 48, 8, 12, health / 2);
		joint.attach(this, 36, 48);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 4, joint.y + 24, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, -4, 12);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x + 20, y + 48, 8, 36, health / 2);
		joint.attach(this, 20, 48);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 4, joint.y + 36, Enemy01Type.Circle);
		enemy.health = health;
		enemy.attach(joint, -4, 36);
		parts.push(enemy);
	}
	
}