package ships;

import hage.HGE;
import hage.HGEObject;
import hage.HGEGroup;
import kha.Color;
import ships.Enemy01.Enemy01Type;

/**
 * ...
 * @author JanGamesCo
 */
class Boss03 extends EnemyBase
{
	public var isBoss:Bool;	
	
	public var parts:HGEGroup<HGEObject>;
	
	public function new(X:Float=0, Y:Float=0) 
	{
		parts = new HGEGroup();
		
		super(X, Y, 64, 64);
		
		//Border
		borderColor = Color.fromValue(0xFFFF3030);
		borderStrength = 2;	
		
		health = 12;
		
		growth = 6;
		
		reset();
	}
	
	override public function update():Void 
	{
		super.update();
		
		if (isBoss && Data.the.level != -1) {
			x = Math.sin(HGE.lastTime * 0.25) * (HGE.width - 160) / 2 + HGE.width / 2 - width / 2;
			if(y > 100) { velocity.set(0, 0); }
		}
	}
	
	override public function kill():Void 
	{
		super.kill();
		
		if (isBoss) {
			Data.the.game.nextLevel();
		}
	}
	
	override public function reset():Void 
	{
		super.reset();
		
		for (part in parts.members) {
			part.detach();
			part.kill();
		}
		parts = new HGEGroup();
		
		isBoss = false;
		
		health = 10;
		
		var joint:Joint = Data.the.jointPool.create(x + 64, y + 36, 24, 8, health / 2);
		joint.attach(this, 64, 28);
		parts.push(joint);
		
		var enemy:Enemy01 = Data.the.enemy01Pool.create(joint.x + 25, joint.y - 4, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, 25, -4);
		parts.push(enemy);
		
		var joint2:Joint = Data.the.jointPool.create(x + 4, y + 16, 8, 48, health / 2);
		joint2.attach(enemy, 4, 16);
		parts.push(joint2);
		
		enemy = Data.the.enemy01Pool.create(joint.x - 4, joint.y + 48, Enemy01Type.Circle);
		enemy.health = health;
		enemy.attach(joint2, -4, 48);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x + 8, y + 20, 24, 8, health / 2);
		joint.attach(joint2, 8, 20);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 24, joint.y + 4, Enemy01Type.Triangle);
		enemy.health = health;
		enemy.attach(joint, 24, 4);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x - 24, y + 36, 24, 8, health / 2);
		joint.attach(this, -24, 28);
		parts.push(joint);
		
		enemy = Data.the.enemy01Pool.create(joint.x - 16, joint.y - 4, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint, -16, -4);
		parts.push(enemy);
		
		joint2 = Data.the.jointPool.create(x + 4, y + 16, 8, 48, health / 2);
		joint2.attach(enemy, 4, 16);
		parts.push(joint2);
		
		enemy = Data.the.enemy01Pool.create(joint.x - 4, joint.y + 48, Enemy01Type.Circle);
		enemy.health = health;
		enemy.attach(joint2, -4, 48);
		parts.push(enemy);
		
		joint = Data.the.jointPool.create(x - 24, y + 20, 24, 8, health / 2);
		joint.attach(joint2, -24, 20);
		parts.push(joint);
		
		joint2 = Data.the.jointPool.create(x + 16, y + 20, 112, 8, health / 2);
		joint2.attach(enemy, 16, 4);
		parts.push(joint2);
		
		enemy = Data.the.enemy01Pool.create(joint.x, joint.y + 4, Enemy01Type.Triangle);
		enemy.health = health;
		enemy.attach(joint, 0, 4);
		parts.push(enemy);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 16, joint.y + 8, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint2, 16, 8);
		parts.push(enemy);
		
		enemy = Data.the.enemy01Pool.create(joint.x + 80, joint.y + 8, Enemy01Type.Square);
		enemy.health = health;
		enemy.attach(joint2, 80, 8);
		parts.push(enemy);
	}
	
}