package ships;

import hage.HGEData.SpriteType;
import hage.HGEVector2;
import kha.Color;

enum Enemy01Type {
	Circle;
	Triangle;
	Square;
}

/**
 * ...
 * @author JanGamesCo
 */
class Enemy01 extends EnemyBase
{
	public var type:Enemy01Type;

	public function new(X:Float=0, Y:Float=0, EType:Enemy01Type)
	{		
		type = EType;
		
		super(X, Y, 8, 8);
		
		//Width and height
		width = 16;
		height = 16;
		radius = 8;
		
		//origin.x = 8;
		//origin.y = 8;
		
		//Border
		borderColor = Color.fromValue(0xFFFF3030);
		borderStrength = 2;
		
		//Player growth
		growth = 1;
		
		//Timers and firerates
		shootRate = 3;
		
		//Reset
		reset();
	}
	
	override public function update():Void 
	{
		super.update();
	}
	
	override public function revive():Void 
	{
		super.revive();
		
		origin.x = 0;
		origin.y = 0;
		
		//Circular sprite
		switch (type) 
		{
			case Circle:
				spritetype = SpriteType.CIRCLE;
				growth = 3;
			case Square:
				spritetype = SpriteType.RECTANGLE;
				growth = 1;
			case Triangle:
				spritetype = SpriteType.TRIANGLE;
				growth = 2;
				origin.x = 6;
				origin.y = 8;
				angularVelocity = 3;
			default:
				
		}
		
		//Velocity
		velocity.add(new HGEVector2(0, 50));	
		
		//Health
		health = 1;
	}
	
	override public function shoot():Void 
	{
		super.shoot();
		
		switch (type) 
		{
			case Circle:
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(-Math.PI * 0.2);
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(-Math.PI * 0.1);
				Data.the.enemyPool.fire(x + width / 4, y);
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(Math.PI * 0.1);
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(Math.PI * 0.2);
			case Square:
				Data.the.enemyPool.fire(x + width / 4, y);
			case Triangle:
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(angle - Math.PI * 0.5);
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(angle - Math.PI * 1.166);
				Data.the.enemyPool.fire(x + width / 4, y).velocity.rotate(angle - Math.PI * 1.832);
			default:
				
		}
	}
	
}